#ifndef __EM28XX_AAD_H
#define __EM28XX_AAD_H

#include <linux/poll.h>
#include <linux/fs.h>
#include <linux/device.h>
//#include <linux/mutex.h>
#include <linux/compiler.h> /* need __user */

#define MAX_USBKHELPER_DEVS 10

struct rb_info {
    spinlock_t __lock;
    u32 left;
    u32 right;
    u32 pos;
    u32 bufsize;
    u8 *buffer;
};

#define USBKHELPER_BUFS 10 
#define USBKHELPER_NUM_PACKETS 64
#define USBKHELPER_MAX_PACKET_SIZE 940

struct usbkhelper_info {
    u32 __id;
    u8 __devname[50];
#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 26)
    struct class_device *__cdev;
#else
    struct device *__cdev;
#endif
    int __major;
    struct class *__class;
    struct list_head __usbkhelper_devlist;
    struct rb_info *__usbkhelper_rb;
    u8 __curr_rb;
    struct usb_device *__udev;
    u8 *transfer_buffer[USBKHELPER_BUFS];
    struct urb *urb[USBKHELPER_BUFS];
    int (*__callback)(void *, unsigned int cmd, void *arg);
    void *__cb_priv;
    wait_queue_head_t wait;
    wait_queue_head_t disconnect;
    int shutdown;
    int stop_transfer;
    int bulk_transfer;
    int data_available;
    int users;
    int transfer_started;
    struct mutex lockcmd;
    int busid;
    int devid;
    void *accel_ptr;
    uint8_t use_acceleration;
    int (*bcm_xpt_clip_enqueue)(void *ptr, u8 *data, ssize_t size, int flag);
};

#endif

